package com.usky.fire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.usky.common.core.bean.CommonPage;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.fire.domain.DemFireAccidentDesc;
import com.usky.fire.mapper.DemFireAccidentDescMapper;
import com.usky.fire.service.DemFireAccidentDescService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 火灾事故说明总表 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-09-13
 */
@Service
public class DemFireAccidentDescServiceImpl extends AbstractCrudService<DemFireAccidentDescMapper, DemFireAccidentDesc> implements DemFireAccidentDescService {

    @Override
    public CommonPage<DemFireAccidentDesc> fireAccidentExplainList(String companyCode, String startDate, String endDate, Integer pageNum, Integer pageSize) {
        IPage<DemFireAccidentDesc> page = new Page<>(pageNum, pageSize);
        LambdaQueryWrapper<DemFireAccidentDesc> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.between(StringUtils.isNotBlank(startDate) & StringUtils.isNotBlank(endDate), DemFireAccidentDesc::getAlarmTime, startDate, endDate)
                .orderByDesc(DemFireAccidentDesc::getId);
        page = this.page(page, queryWrapper);
        return new CommonPage<>(page.getRecords(), page.getTotal(), pageSize, pageNum);
    }

    @Override
    public List<DemFireAccidentDesc> fireAccidentStatistic(String companyCode, String startDate, String endDate) {
        LambdaQueryWrapper<DemFireAccidentDesc> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.between(StringUtils.isNotBlank(startDate) & StringUtils.isNotBlank(endDate), DemFireAccidentDesc::getAlarmTime, startDate, endDate)
                .orderByDesc(DemFireAccidentDesc::getId);
        List<DemFireAccidentDesc> list = this.list(queryWrapper);
        return list;
    }

    @Override
    public List<DemFireAccidentDesc> fireAccidentSimpleConList(String companyCode, String startDate, String endDate) {
        LambdaQueryWrapper<DemFireAccidentDesc> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.between(StringUtils.isNotBlank(startDate) & StringUtils.isNotBlank(endDate), DemFireAccidentDesc::getAlarmTime, startDate, endDate)
                .orderByDesc(DemFireAccidentDesc::getId);
        List<DemFireAccidentDesc> list = this.list(queryWrapper);
        return list;
    }

    @Override
    public List<DemFireAccidentDesc> fireAccidentConList(String companyCode, String startDate, String endDate) {
        LambdaQueryWrapper<DemFireAccidentDesc> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.between(StringUtils.isNotBlank(startDate) & StringUtils.isNotBlank(endDate), DemFireAccidentDesc::getAlarmTime, startDate, endDate)
                .orderByDesc(DemFireAccidentDesc::getId);
        List<DemFireAccidentDesc> list = this.list(queryWrapper);
        return list;
    }

}
